#include "snake.h"
#include <stdlib.h>		/* malloc etc.. */
#include <string.h>		/* string handling funx */

/* external functions */
extern int rand_between ( int low, int high );

/* public function */
snake *snake_make ( void );

/* allocate space for a new (1-cell-big) snake.
 * initialize snake's structure members
 * assign a random position
 */
snake *snake_make ( void )
{
	int x, y, dir;
	snake *new;	/* new snake pointer */

	do
	{
		x = rand_between (0, ARENA_WIDTH-1);
		y = rand_between (0, ARENA_HEIGHT-1);
	} while ( IS_SNAKE(ARENAGET(y,x)) );

	dir = rand_between (0, 3);

	/* allocate memory for the new snake */
	new = (snake *) malloc(sizeof(snake));
	if ( ! new ) { /* no more memory available */
		return NULL;
	}
		

	/* allocate space for the head/tail */
	new->head = new->tail = (snakebody *) malloc(sizeof(snakebody));

	/* set head/tail types */
	new->head->type = SNAKE;

	/* set self referece */
	new->head->self = new;

	/* set head/tail references to NULL */
	new->head->next = NULL;
	new->head->prev = NULL;

	/* set snake's head and tail chains */
	new->head->cell.y = y;	/* == new->tail->y */
	new->head->cell.x = x;	/* == new->tail->x */

	/* set snake's length */
	new->length = 1;

	/* set fake snake's look (will be set by register_player()) */
	new->look = 'x';

	/* give snake a life */
	new->died = 0;

	/* mark it growing */
	new->grow = 0;

	/* set snake's direction */
	new->dir = dir;

	/* set snake's score */
	new->score = 0;

	/* return the new snake */
	return new;
}
